package co.hyperverge.hypersnapsdk.hypersnapsdk_flutter;

import android.content.Context;
import android.util.Log;

import co.hyperverge.hypersnapsdk.HyperSnapSDK;
import co.hyperverge.hypersnapsdk.listeners.SessionStatusCallback;
import co.hyperverge.hypersnapsdk.objects.HVDocConfig;
import co.hyperverge.hypersnapsdk.objects.HVError;
import co.hyperverge.hypersnapsdk.objects.HVFaceConfig;
import co.hyperverge.hypersnapsdk.objects.HyperSnapParams;

public class FLHyperSnapSDK {

    public void initialize(Context context, String appId, String appName, String regionValue) {
        String[] regionParams = regionValue.split("\\.");
        HyperSnapParams.Region region = getHVHyperSnapParam(regionParams[0],
                regionParams[1], HyperSnapParams.Region.class);
        HyperSnapSDK.init(context, appId, appName, region);
    }

    public void startUserSession(String userID) {
        if (userID != null && userID.isEmpty()) {
            HyperSnapSDK.startUserSession(new SessionStatusCallback() {
                @Override
                public void onFailure(HVError hvError) {
                    Log.e("startUserSession", "hvError " + hvError.getErrorCode());
                }
            });
        } else {
            HyperSnapSDK.startUserSession(userID, new SessionStatusCallback() {
                @Override
                public void onFailure(HVError hvError) {
                    Log.e("startUserSession", "hvError " + hvError.getErrorCode());
                }
            });
        }
    }

    public void endUserSession() {
        HyperSnapSDK.endUserSession();
    }

    public <T> T getHVHyperSnapParam(String enumClass, String param, Class<T> type) {
        switch (enumClass) {
            case "Product": {
                return type.cast(HyperSnapParams.Product.valueOf(param));
            }
            case "Region": {
                return type.cast(HyperSnapParams.Region.valueOf(param));
            }
            case "Document": {
                return type.cast(HVDocConfig.Document.valueOf(param));
            }
            case "LivenessMode": {
                return type.cast(HVFaceConfig.LivenessMode.valueOf(param));
            }
            default: {
                return null;
            }
        }
    }
}
