//
//  FLHyperSnapSDK.swift
//


import Foundation
import HyperSnapSDK

public class FLHyperSnapSDK {
    
    static func initialize(appId: String, appName: String, regionValue: String) {
        let regionParams = regionValue.components(separatedBy: ".")

        let region = getHVHyperSnapParam(enumClass: regionParams[0], param: regionParams[1], type: HyperSnapParams.Region.self)
        HyperSnapSDKConfig.initialize(appId: appId, appKey: appName, region: region )
    }
    
    static func startUserSession(userID: String) {
        if(userID != nil && userID.isEmpty){
            HyperSnapSDKConfig.startUserSession()
        } else {
            HyperSnapSDKConfig.startUserSession(userID)
        }
    }
    
    static func endUserSession() {
        HyperSnapSDKConfig.endUserSession()
    }
    
    static func getHVHyperSnapParam<T>(enumClass: String, param: String, type: T.Type) -> T {
        switch param {
        case "India":
            return HyperSnapParams.Region.India as! T
        case "AsiaPacific":
            return HyperSnapParams.Region.AsiaPacific as! T
        case "UnitedStates":
            return HyperSnapParams.Region.UnitedStates as! T
        default:
            return HyperSnapParams.Region.India as! T
        }
        
//        switch enumClass {
//        case "Product":
//            return NSClassFromString("HyperSnapParams.Product.\(param)") as! T
//        case "Region":
//            let member = "\(param)"
//            return HyperSnapParams.Region.member as! T
//        case "Document":
//            return NSClassFromString("HVDocConfig.Document.\(param)") as! T
//        case "LivenessMode":
//            return NSClassFromString("HVFaceConfig.LivenessMode.\(param)") as! T
//        default:
//            return NSClassFromString("HyperSnapParams.Region.\(param)") as! T
//        }
    }
}
